//thsi test a swicht with 16 cases all with same probability

import ewe.sys.Vm;
public class IfElseTree_switch16 implements OptiTest
{
  private static final String name="'switch' replaced by 'if-else-tree' 16";


  public void findAndSetNumberOfRuns(final int milliSecondsUnoptimised)
  {
    long time;
    numberOfRuns=1;
    for(int i=100; 0<i--;)
    {
      runUnoptimisedVersion();
      runOptimisedVersion();
    }//next i


    int count=0;

    time=System.currentTimeMillis() ;
    while(milliSecondsUnoptimised>(int)(System.currentTimeMillis() -time))
    { runUnoptimisedVersion();
      runOptimisedVersion();
      count++;
    }//wend
    numberOfRuns=count;

//System.err.println(count+" ("+getTestname()+")");//                    //DEBUG

  }//end-method
  private static int numberOfRuns=1;





  public final String getTestname()
  {
    return name;
  }


  public static void main(final String[] args)
  {
    (new IfElseTree_switch16()).runForEver();
  }



  public void runForEver()
  {
    //!!! not supported for EWE
  }//end-method



  public int runUnoptimisedVersion()
  {
    long time;
    time=System.currentTimeMillis() ;
//    System.err.println("norm: (IfElseTree_switch16)"+switch_Version(numberOfRuns));
    switch_Version(numberOfRuns);
    return (int)(System.currentTimeMillis() -time);
  }//end-method


  public int runOptimisedVersion()
  {
    long time;
    time=System.currentTimeMillis() ;
//    System.err.println("opti: (IfElseTree_switch16)"+ifElseTree(numberOfRuns));
    ifElseTree(numberOfRuns);
    return (int)(System.currentTimeMillis() -time);
  }//end-method


//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  private static int switch_Version(int anz)
  {
    int erg=7;
    anz*=200000;

    while(0<anz--)
    {
      int j=-1;
      final int i=anz&15;
      switch(i)
      {
        case  0:j=299; break;
        case  1:j=298; break;
        case  2:j=297; break;
        case  3:j=296; break;
        case  4:j=295; break;
        case  5:j=294; break;
        case  6:j=293; break;
        case  7:j=292; break;
        case  8:j=291; break;
        case  9:j=290; break;
        case 10:j=289; break;
        case 11:j=288; break;
        case 12:j=287; break;
        case 13:j=286; break;
        case 14:j=285; break;
        case 15:j=284; break;
      }//end-switch
      erg+=j;
    }//wend
    return erg;
  }//end-method

  private static int ifElseTree(int anz)
  {
    int erg=7;
    anz*=200000;

    while(0<anz--)
    {
      int j=-1;
      final int i=anz&15;

      if(8>i)
      { if(4>i)
        { if(2>i)
          { if(0==i)
              j=299;
            else if(1==i)
              j=298;
          }
          else // 2,3
          { if(2==i)
              j=297;
            else if(3==i)
              j=296;
          }
        }
        else // 4 .. 7
        { if(6>i)
          { if(4==i)
              j=295;
            else if(5==i)
              j=294;
          }
          else
          { if(6==i)
              j=293;
            else if(7==i)
              j=292;
          }
        }
      }
      else // 8 ... 15
      { if(12>i)
        { if(10>i)
          { if(8==i)
              j=291;
            else if(9==i)
              j=290;
          }
          else
          { if(10==i)
              j=289;
            else if(11==i)
              j=288;
          }
        }
        else
        { if(14>i)
          { if(12==i)
              j=287;
            else if(13==i)
              j=286;
          }
          else
          { if(14==i)
              j=285;
            else if(15==i)
              j=284;
          }
        }
      }
      erg+=j;
    }//wend
    return erg;
  }//end-method

}//end-class
