//server: 76,6%   client: 78,6%

//Last Modified: 2007.04.30
import ewe.sys.Vm;
public class If_Modulo implements OptiTest
{
  private static final String name="'x%=17' replaced by 'if(x>=17) x-=17'";


  public void findAndSetNumberOfRuns(final int milliSecondsUnoptimised)
  {
    long time;
    numberOfRuns=1;
    for(int i=100; 0<i--;)
    {
      runUnoptimisedVersion();
      runOptimisedVersion();
    }//next i


    int count=0;

    time=System.currentTimeMillis() ;
    while(milliSecondsUnoptimised>(int)(System.currentTimeMillis() -time))
    { runUnoptimisedVersion();
      runOptimisedVersion();
      count++;
    }//wend
    numberOfRuns=count;

//System.err.println(count+" ("+getTestname()+")");//                    //DEBUG

  }//end-method
  private static int numberOfRuns=1;




  public final String getTestname()
  {
    return name;
  }



  public static void main(final String[] args)
  {
    (new If_Modulo()).runForEver();
  }



  public void runForEver()
  {
    //!!! not supported for EWE
  }//end-method



  public int runUnoptimisedVersion()
  {
    long time;
    time=System.currentTimeMillis() ;
//    System.err.println("norm: (If_Modulo)"+modulo_X(numberOfRuns));
    modulo_X(numberOfRuns);
    return (int)(System.currentTimeMillis() -time);
  }//end-method


  public int runOptimisedVersion()
  {
    long time;
    time=System.currentTimeMillis() ;
//    System.err.println("opti: (If_Modulo)"+if_grater(numberOfRuns));
    if_grater(numberOfRuns);
    return (int)(System.currentTimeMillis() -time);
  }//end-method


//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  private static int modulo_X(int maxVal)
  {
    int erg=7;
    maxVal*=100000;

    int i=0;
    while (0<maxVal--)
    {
      i+=13;
      i%=17;
      erg+=i;
    }//wend
    return erg;
  }//end-method

  private static int if_grater(int maxVal)
  {
    int erg=7;
    maxVal*=100000;

    int i=0;
    while (0<maxVal--)
    {
      i+=13;
      if(17<=i)
        i-=17;
      erg+=i;
    }//wend
    return erg;
  }//end-method

}//end-class
