//Fazit: SHIFT statt DIV bringt sehr viel  server: 94,5%  client: 85,2% schneller
//       >> genauso teuer wie >>>

import ewe.sys.Vm;
public class Shift_Div implements OptiTest
{
  private static final String name="'x div 16' replaced by 'x >> 4'";

  private static final int faktorArrayDiv []={2,4,8,16,32,64,128,256,512,1024,
      2048,4096,8192,16384,32768,65536,131072,262144,524288,1048576,
      2097152,4194304,8388608,16777216,33554432,67108864,134217728,268435456,536870912};
  private static final int faktorArrayShift []={1,2,3,4,5,6,7,8,9,10,
      11,  12,  13,  14,   15,   16,   17,    18,    19,    20,
      21,     22,     23,     24,      25,      26,      27,       28,       29};


  public void findAndSetNumberOfRuns(final int milliSecondsUnoptimised)
  {
    long time;
    numberOfRuns=1;
    for(int i=100; 0<i--;)
    {
      runUnoptimisedVersion();
      runOptimisedVersion();
    }//next i


    int count=0;

    time=System.currentTimeMillis() ;
    while(milliSecondsUnoptimised>(int)(System.currentTimeMillis() -time))
    { runUnoptimisedVersion();
      runOptimisedVersion();
      count++;
    }//wend
    numberOfRuns=count;

//System.err.println(count+" ("+getTestname()+")");//                    //DEBUG

  }//end-method
  private static int numberOfRuns=1;




  public static void main(final String[] args)
  {
    (new Shift_Div()).runForEver();
  }//end-method


  public String getTestname()
  {
    return name;
  }

  public int runUnoptimisedVersion()
  {
    long time;
    time=System.currentTimeMillis() ;
//    System.err.println("norm: (Shift_Div)"+div(numberOfRuns));
    div(numberOfRuns);
    return (int)(System.currentTimeMillis() -time);
  }//end-method

  public int runOptimisedVersion()
  {
    long time;
    time=System.currentTimeMillis() ;
//    System.err.println("opti: (Shift_Div)"+shift_div(numberOfRuns));
    shift_div(numberOfRuns);
    return (int)(System.currentTimeMillis() -time);
  }//end-method

  public void runForEver()
  {
    //!!! not supported for EWE
  }//end-method


//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
//- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
  private static int div(int anz)
  {
    final int len=faktorArrayDiv.length;
    anz*=200;
    int erg=7;
    while(0<=--anz)
    {
      for(int llen=len; 0<llen; llen--)
      {
        for(int index=0; llen>index; index++) //8+8+8+4 = 28 28Bit=536870912 Zahlen
        {
          final int f=faktorArrayDiv[index];
          erg+=anz/f;
          erg+=(anz&(-2^llen))/f;
          erg+=(anz&(-13^llen))/f;
          erg+=(anz&(-47^llen))/f;
          erg+=(anz&(-757^llen))/f;
          erg+=(anz&(-47647^llen))/f;

          erg+=(anz&(-147^llen))/f;
          erg+=(anz&(-363^llen))/f;
          erg+=(anz&(-83456^llen))/f;
          erg+=(anz&(-5387^llen))/f;
          erg+=(anz&(-3997^llen))/f;
        }//next index
      }
    }//wend
    return erg;
  }//end-method

  private static int shift_div(int anz)
  {
    final int len=faktorArrayDiv.length;
    anz*=200;
    int erg=7;
    while(0<=--anz)
    {
      for(int llen=len; 0<llen; llen--)
      {
        for(int index=0; llen>index; index++) //8+8+8+4 = 28 28Bit=536870912 Zahlen
        {
          final int f=faktorArrayShift[index];
          erg+=anz>>f;
          erg+=(anz&(-2^llen))>>f;
          erg+=(anz&(-13^llen))>>f;
          erg+=(anz&(-47^llen))>>f;
          erg+=(anz&(-757^llen))>>f;
          erg+=(anz&(-47647^llen))>>f;

          erg+=(anz&(-147^llen))>>f;
          erg+=(anz&(-363^llen))>>f;
          erg+=(anz&(-83456^llen))>>f;
          erg+=(anz&(-5387^llen))>>f;
          erg+=(anz&(-3997^llen))>>f;
        }//next index
      }
    }//wend
    return erg;
  }//end-method

}//end-class
